<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>Bitcoin one way channel</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="assets/js/search.js" data-base=".">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="index.html" class="title">Bitcoin one way channel</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="globals.html">Globals</a>
				</li>
			</ul>
			<h1> Bitcoin one way channel</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<div class="tsd-panel tsd-typography">
				<h1 id="bitcoin-one-way-channel-tx">Bitcoin One Way Channel Tx</h1>
				<h2 id="library-purposes">Library purposes</h2>
				<p>This library is will be used by the &quot;strategic library&quot; to provide a complete implementation of payment channel over the bitcoin protocol. This library is not responsible for managing the state of the channel and handle network interaction, the other library do it.</p>
				<p>This library has to provide two public interfaces: client and server. These interfaces provide helpers to:</p>
				<ul>
					<li><strong>create</strong> all needed transactions for a given state</li>
					<li><strong>sign</strong> a given transaction for a given state</li>
					<li><strong>verify</strong> a given transaction for a given state</li>
				</ul>
				<h2 id="installation">Installation</h2>
				<p>Install node.js and (optional) <a href="https://yarnpkg.com/en/">yarn</a>. Prefer yarn over npm, it&#39;s faster.</p>
				<p>Install dependencies:</p>
				<pre><code class="lang-bash">yarn install
</code></pre>
				<h2 id="testing">Testing</h2>
				<h3 id="execute-linter">Execute linter</h3>
				<p>The linter config is locate in <code>tslint.json</code>. To execute the linter in console mode run:</p>
				<pre><code class="lang-bash">yarn lint
</code></pre>
				<h3 id="execute-tests">Execute tests</h3>
				<p>To compile, run the tests and the tests coverage:</p>
				<pre><code class="lang-bash">yarn <span class="hljs-built_in">test</span>
</code></pre>
				<p>You can run tests in watch mode (the compileOnSave file in tsconfig is set to true):</p>
				<pre><code class="lang-bash">yarn <span class="hljs-built_in">test</span>:run -- --watch
</code></pre>
				<h3 id="write-tests">Write tests</h3>
				<p>Write tests in <code>test/</code> folder with the naming structure <code>[file/scenario].test.ts</code>. Group your tests in files, files is executed in parallel in separate threads and tests in each files is executed in parallel via async. Name carefully your tests. You can import all you want in the lib and dependencies.</p>
				<pre><code class="lang-javascript"><span class="hljs-keyword">import</span> test <span class="hljs-keyword">from</span> <span class="hljs-string">'ava'</span>;
<span class="hljs-keyword">import</span> { crypto } <span class="hljs-keyword">from</span> <span class="hljs-string">'bitcoinjs-lib'</span>;

<span class="hljs-keyword">import</span> { revHashFromSecret } <span class="hljs-keyword">from</span> <span class="hljs-string">'../lib/common/secrets/revhash'</span>;
<span class="hljs-keyword">import</span> { deriveRevSecret } <span class="hljs-keyword">from</span> <span class="hljs-string">'../lib/common/secrets/revsecret'</span>;


test(<span class="hljs-string">'A good name here'</span>, t =&gt; {
    t.deepEqual([<span class="hljs-number">1</span>, <span class="hljs-number">4</span>, <span class="hljs-number">3</span>], [<span class="hljs-number">1</span>, <span class="hljs-number">4</span>, <span class="hljs-number">3</span>]);
});
</code></pre>
				<h2 id="building">Building</h2>
				<h3 id="building-with-tsc">Building with tsc</h3>
				<p>Building with <code>tsc</code> compile all <code>.ts</code> present in <code>lib/</code> and <code>test/</code> and output the result in <code>build/</code>. The configuration is located in  <code>tsconfig.json</code>. To build with <code>tsc</code> run:</p>
				<pre><code class="lang-bash">yarn build
</code></pre>
				<h3 id="building-with-webpack-create-a-bundle-">Building with webpack (create a bundle)</h3>
				<p>The actual webpack confing is in <code>config/webpack.config.debug.js</code>. The bundle is created in the <code>dist/</code> directory and contain a standalone bundle. To compile the <code>bundle.js</code> run:</p>
				<pre><code class="lang-bash">yarn build:dist
</code></pre>
				<p>The bundle is used by the demo application, be sure to compile it before running the demo.</p>
				<h3 id="building-the-documentation">Building the documentation</h3>
				<p>The documentation is compiled with <code>typedoc</code> and the result is output into the <code>doc/</code> folder. To compile the documentation run:</p>
				<pre><code class="lang-bash">yarn build:doc
</code></pre>
				<p><strong>Serving the documentation</strong></p>
				<pre><code class="lang-bash"><span class="hljs-built_in">cd</span> doc/ &amp;&amp; python -m SimpleHTTPServer 8000
</code></pre>
				<h2 id="usage-example">Usage Example</h2>
				<p>Create a client for interacting with the channel and create some transactions:</p>
				<pre><code class="lang-javascript"><span class="hljs-keyword">import</span> channel <span class="hljs-keyword">from</span> <span class="hljs-string">'channel.js'</span>

<span class="hljs-keyword">var</span> channel = <span class="hljs-keyword">new</span> channel.Channel(
  <span class="hljs-string">'tprv8ZgxMBicQKsPdy1GPK3UWbNVyvcttQqEBtQ3DprwSf5PRE7yuEzCijSxA5GtYNZdZP579QRA5nXSXXY9ZmXtQWNwma6UBQzkTBMChkvS7rm'</span>, <span class="hljs-comment">// clientSeed</span>
  <span class="hljs-string">'tpubDDmLggsXnurnvAZkyYomS43Qi9Ps9t62nN7nbCtPNnuN8a84HX5G2xBUr3MCmYyR4FYc73gukigAFrTKBYUPY41q5d88bETBHxcW5ChALoa'</span>, <span class="hljs-comment">// providerAccPubkey</span>
  <span class="hljs-number">4</span>, <span class="hljs-comment">// accountId</span>
  <span class="hljs-string">'testnet'</span> <span class="hljs-comment">// network</span>
)

channel.createSpendRefund(
  <span class="hljs-number">0</span>, <span class="hljs-comment">// i: number</span>
  <span class="hljs-number">1</span>, <span class="hljs-comment">// n: number</span>
  channel.Btc.fromSatoshis(<span class="hljs-number">200</span>), <span class="hljs-comment">// feePerByte: Btc</span>
  <span class="hljs-string">'mkzsShsvbAZW2EgJnJoggzgkEQcyVk9L1k'</span>,
  <span class="hljs-number">2</span> <span class="hljs-comment">// locktime</span>
).then(<span class="hljs-function"><span class="hljs-params">res</span> =&gt;</span> {
  transaction.spendRefund = res
})
</code></pre>
				<p>Create a server for interacting with the client and broadcast a hypothetic transaction:</p>
				<pre><code class="lang-javascript"><span class="hljs-keyword">import</span> channel <span class="hljs-keyword">from</span> <span class="hljs-string">'channel.js'</span>

<span class="hljs-keyword">var</span> serverChannel = <span class="hljs-keyword">new</span> channel.ServerChannel(
  <span class="hljs-string">'tprv8ZgxMBicQKsPdKBmPRHBmU8MfbFoa96phv185cxBVTFewMfR6Z4oHqo3vNtYz2PwypxXU2Pvw5iKiz9RFhnpK6LFoUEu5zgMx6QDLF8YZbD'</span>, <span class="hljs-comment">// providerSeed</span>
  <span class="hljs-string">'tpubDCQCgbFWWaH2rxQrCYVUopEmBgnh7Q8BMESC1gC8dseRwLZv4UqhNwsMDRis1newBWXvZWKrmJuUu2KQsdHjzuCTRU4XadZjaJ5bUUPP99u'</span>, <span class="hljs-comment">// clientAccPubkey</span>
  <span class="hljs-number">4</span>,
  <span class="hljs-string">'testnet'</span> <span class="hljs-comment">// network</span>
)

serverChannel.getAdapter()
  .broadcastTx(transaction.settlementSignedByClientAndServer).then(<span class="hljs-function">(<span class="hljs-params">res</span>) =&gt;</span> {
    transaction.settlementIsSpend = <span class="hljs-literal">true</span>
  })
</code></pre>
				<h2 id="running-demo">Running demo</h2>
				<pre><code class="lang-bash"><span class="hljs-comment"># go to demo folder</span>
<span class="hljs-built_in">cd</span> demo

<span class="hljs-comment"># install dependencies</span>
yarn install

<span class="hljs-comment"># serve with hot reload at localhost:8080</span>
yarn dev
</code></pre>
				<h2 id="git-conventions">Git conventions</h2>
				<h3 id="branch-naming-convention">Branch naming convention</h3>
				<p>Start your branch name with one of these prefix.</p>
				<pre><code>feature/           Feature I'm adding or expanding
release/vX.X.X     Start a release
hotfix/            Hotfixes arise <span class="hljs-keyword">from</span> the necessity <span class="hljs-keyword">to</span> act immediately upon an undesired <span class="hljs-keyword">state</span> of a live production version
</code></pre><h2 id="fee-strategies-settlement-refund-">Fee strategies (settlement &amp; refund)</h2>
				<h3 id="settlement-transaction">Settlement Transaction</h3>
				<ul>
					<li>Fees deducted from change amount (client pays all fees for settlement, but does not control when settlement happen) :s</li>
					<li>Fees deducted from settlement amount (provider pays all fees for settlement)</li>
					<li>Split fees.  This is possible but can get complicated as we would need to enforce minimum &amp; maximum fee we consider valid.</li>
				</ul>
				<h3 id="refund-transaction">Refund Transaction</h3>
				<ul>
					<li>Fees deducted from settlement amount (expensive + risk of attack?)</li>
					<li>Fees deducted from refund amount (client pays all fees)</li>
				</ul>
				<h2 id="to-do">To-Do</h2>
				<ul>
					<li>[X] Test the webpack bundle</li>
					<li>[X] Improve README</li>
					<li>[ ] More usage exemple</li>
					<li>[ ] Cosign</li>
					<li>[X] ChannelTx</li>
					<li>[X] refund + revoke refund</li>
				</ul>
				<p>Typescript things</p>
				<ul>
					<li>[ ] Make key generation + bitcoinjs work in react native</li>
				</ul>
			</div>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals  ">
						<a href="globals.html"><em>Globals</em></a>
					</li>
					<li class=" tsd-kind-module">
						<a href="modules/derivation.html">derivation</a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
					<li class=" tsd-kind-class">
						<a href="classes/btc.html" class="tsd-kind-icon">Btc</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/client.html" class="tsd-kind-icon">Client</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/clientkernel.html" class="tsd-kind-icon">Client<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/kernel.html" class="tsd-kind-icon">Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/multisig.html" class="tsd-kind-icon">Multisig</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/multisigclient.html" class="tsd-kind-icon">Multisig<wbr>Client</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/multisigprovider.html" class="tsd-kind-icon">Multisig<wbr>Provider</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/protocol.html" class="tsd-kind-icon">Protocol</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pubkey</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/revpubkeyclient.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Client</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/revpubkeyprovider.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Provider</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/server.html" class="tsd-kind-icon">Server</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/serverkernel.html" class="tsd-kind-icon">Server<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/testkernel.html" class="tsd-kind-icon">Test<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/channeladdress.html" class="tsd-kind-icon">Channel<wbr>Address</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/channelstatetransition.html" class="tsd-kind-icon">Channel<wbr>State<wbr>Transition</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/clientproviderpubkeys.html" class="tsd-kind-icon">Client<wbr>Provider<wbr>Pubkeys</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/requestapi.html" class="tsd-kind-icon">Request<wbr>Api</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pub<wbr>Key</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/tx.html" class="tsd-kind-icon">Tx</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/utxo.html" class="tsd-kind-icon">Utxo</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/utxoandwif.html" class="tsd-kind-icon">Utxo<wbr>And<wbr>Wif</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#apiname" class="tsd-kind-icon">Api<wbr>Name</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#channeltx" class="tsd-kind-icon">Channel<wbr>Tx</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#networkname" class="tsd-kind-icon">Network<wbr>Name</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#transition" class="tsd-kind-icon">Transition</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#biginteger" class="tsd-kind-icon">Big<wbr>Integer</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#op_checksequenceverify" class="tsd-kind-icon">OP_<wbr>CHECKSEQUENCEVERIFY</a>
					</li>
					<li class=" tsd-kind-variable">
						<a href="globals.html#apiname" class="tsd-kind-icon">api<wbr>Name</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#host" class="tsd-kind-icon">host</a>
					</li>
					<li class=" tsd-kind-variable">
						<a href="globals.html#networkname" class="tsd-kind-icon">network<wbr>Name</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapi" class="tsd-kind-icon">BTCApi</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapiinsight" class="tsd-kind-icon">BTCApi<wbr>Insight</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapirpc" class="tsd-kind-icon">BTCApiRPC</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#csvrevpubkeyoutput" class="tsd-kind-icon">csv<wbr>Rev<wbr>Pub<wbr>Key<wbr>Output</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#derivechanneladdress" class="tsd-kind-icon">derive<wbr>Channel<wbr>Address</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriverevpubkey" class="tsd-kind-icon">derive<wbr>Rev<wbr>Pubkey</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriverevsecret" class="tsd-kind-icon">derive<wbr>Rev<wbr>Secret</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriveusernode" class="tsd-kind-icon">derive<wbr>User<wbr>Node</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#fundingtransaction" class="tsd-kind-icon">funding<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#generateseed" class="tsd-kind-icon">generate<wbr>Seed</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getfeeperbyte" class="tsd-kind-icon">get<wbr>Fee<wbr>Per<wbr>Byte</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getoutputs" class="tsd-kind-icon">get<wbr>Outputs</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getpubkeys" class="tsd-kind-icon">get<wbr>Pubkeys</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#refundtransaction" class="tsd-kind-icon">refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#registerchannel" class="tsd-kind-icon">register<wbr>Channel</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#revhashfromsecret" class="tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#revokerefundtransaction" class="tsd-kind-icon">revoke<wbr>Refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#settlementtransaction" class="tsd-kind-icon">settlement<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#spendrefundtransaction" class="tsd-kind-icon">spend<wbr>Refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#statetransition" class="tsd-kind-icon">state<wbr>Transition</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#validbalancesorthrow" class="tsd-kind-icon">valid<wbr>Balances<wbr>OrThrow</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#verifysignature" class="tsd-kind-icon">verify<wbr>Signature</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#withdrawtransaction" class="tsd-kind-icon">withdraw<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-object-literal tsd-is-not-exported">
						<a href="globals.html#common" class="tsd-kind-icon">common</a>
					</li>
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-module"><span class="tsd-kind-icon">Module</span></li>
				<li class="tsd-kind-object-literal"><span class="tsd-kind-icon">Object literal</span></li>
				<li class="tsd-kind-variable"><span class="tsd-kind-icon">Variable</span></li>
				<li class="tsd-kind-function"><span class="tsd-kind-icon">Function</span></li>
				<li class="tsd-kind-function tsd-has-type-parameter"><span class="tsd-kind-icon">Function with type parameter</span></li>
				<li class="tsd-kind-index-signature"><span class="tsd-kind-icon">Index signature</span></li>
				<li class="tsd-kind-type-alias"><span class="tsd-kind-icon">Type alias</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-enum"><span class="tsd-kind-icon">Enumeration</span></li>
				<li class="tsd-kind-enum-member"><span class="tsd-kind-icon">Enumeration member</span></li>
				<li class="tsd-kind-property tsd-parent-kind-enum"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-enum"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-interface"><span class="tsd-kind-icon">Interface</span></li>
				<li class="tsd-kind-interface tsd-has-type-parameter"><span class="tsd-kind-icon">Interface with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-interface"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-interface"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-interface"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-class"><span class="tsd-kind-icon">Class</span></li>
				<li class="tsd-kind-class tsd-has-type-parameter"><span class="tsd-kind-icon">Class with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class"><span class="tsd-kind-icon">Accessor</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-class"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static property</span></li>
				<li class="tsd-kind-call-signature tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="http://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="assets/js/search.js"><' + '/script>');</script>
</body>
</html>